/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* pythag.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

doublereal pythag_ (a, b)
     doublereal *a, *b;
{
   /* System generated locals */
   doublereal ret_val, d__1;

   /* Local variables */
   static doublereal p, q, r__, s, t;

/* ***BEGIN PROLOGUE  PYTHAG */
/* ***REFER TO  EISDOC */

/*     Finds sqrt(A**2+B**2) without overflow or destructive underflow */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE  PYTHAG */

/* ***FIRST EXECUTABLE STATEMENT  PYTHAG */
   p = abs (*a);
   if (abs (*b) > abs (*a))
   {
      p = abs (*b);
   }
   q = abs (*a);
   if (abs (*b) < abs (*a))
   {
      q = abs (*b);
   }
   if (q == 0.)
   {
      goto L20;
   }
 L10:
/* Computing 2nd power */
   d__1 = q / p;
   r__ = d__1 * d__1;
   t = r__ + 4.;
   if (t == 4.)
   {
      goto L20;
   }
   s = r__ / t;
   p += p * 2. * s;
   q *= s;
   goto L10;
 L20:
   ret_val = p;
   return ret_val;
}                                       /* pythag_ */
